package org.eclipse.stp.b2j.core.jengine.internal.utils;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

import org.eclipse.stp.b2j.core.misc.internal.HexData;

public class FileMD5 {
	
	public static byte[] getMD5Sum(File file) throws IOException {
		FileInputStream fin = new FileInputStream(file);
		return getMD5Sum(fin);
	}
	
	public static byte[] getMD5Sum(InputStream in) throws IOException {
		try {
			MessageDigest md = MessageDigest.getInstance("MD5");
			
			int n = 0;
			byte[] buf = new byte[30000];
			while (n != -1) {
				n = in.read(buf);
				if (n > 0) {
					md.update(buf,0,n);
				}
			}
			
			return md.digest();
		
		} catch (IOException e) {
			throw e;
		} catch (NoSuchAlgorithmException e) {
			IOException io = new IOException("Failed to load MD5 algorithm");
			io.initCause(e);
			throw io;
		}
	}
	
	public static byte[] getMD5Sum(byte[] dat) throws IOException {
		try {
			MessageDigest md = MessageDigest.getInstance("MD5");

			md.update(dat);
			
			return md.digest();
			
		} catch (NoSuchAlgorithmException e) {
			IOException io = new IOException("Failed to load MD5 algorithm");
			io.initCause(e);
			throw io;
		}
	}
	
	public static String md5ToString(byte[] digest) {
		return HexData.byteArrayToHexString(digest);
	}
}